#define _WIN32_WINNT 0x0502
#include <windows.h>
#include <stdio.h>

static LRESULT WINAPI WndProc(HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam)
{
    if(message == WM_CLOSE)
        PostQuitMessage(0);
    return DefWindowProcA(hwnd, message, wParam, lParam);
}

void register_classes()
{
    WNDCLASSA cls = {0};

    cls.lpfnWndProc = WndProc;
    cls.hInstance = GetModuleHandleA(0);
    cls.hCursor = LoadCursorA(0, (LPCSTR)IDC_ARROW);
    cls.hbrBackground = (HBRUSH)GetStockObject(WHITE_BRUSH);
    cls.lpszClassName = "sidebyside";
    RegisterClassA(&cls);
}

__declspec(dllexport) BOOLEAN WINAPI RegisterClassNameW(PCWSTR lpClassName)
{
    wprintf(L"RegisterClassNameW called: %s\n", lpClassName);
     register_classes();
    return TRUE;
}

BOOL WINAPI DllMain(HINSTANCE hinstDLL, DWORD fdwReason, LPVOID lpvReserved)
{
     switch (fdwReason)
    {
        case DLL_PROCESS_ATTACH:
            printf("Dll: Registering classes\n");
            break;
    }

    return TRUE;
}
