#define _WIN32_WINNT 0x0502
#include <windows.h>
#include <stdio.h>
#include "Shlobj.h"

void ok(BOOL condition, const char *message)
{
    if(!condition)
        printf(message);
}

void ok(BOOL condition, const char *message, int p1)
{
    if(!condition)
        printf(message, p1);
}

void ok(BOOL condition, const char *message, const char *p1)
{
    if(!condition)
        printf(message, p1);
}

static LRESULT WINAPI WndProc(HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam)
{
    if(message == WM_CLOSE)
        PostQuitMessage(0);
    return DefWindowProcA(hwnd, message, wParam, lParam);
}

void register_classes()
{
    WNDCLASSA cls = {0};

    cls.lpfnWndProc = WndProc;
    cls.hInstance = GetModuleHandleA(0);
    cls.hCursor = LoadCursorA(0, (LPCSTR)IDC_ARROW);
    cls.hbrBackground = (HBRUSH)GetStockObject(WHITE_BRUSH);
    cls.lpszClassName = "sidebyside";
    RegisterClassA(&cls);
}

/* Needs to be run in the folder it was compiled in */
int APIENTRY WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nShowCmd)
{
    ACTCTXW context = {0};
    context.cbSize = sizeof(ACTCTX);
    ULONG_PTR cookie;
    WCHAR current_path[MAX_PATH];
    WCHAR manifest_path[MAX_PATH] ;
    WCHAR assembly_path[MAX_PATH];

    GetCurrentDirectoryW(MAX_PATH, current_path);
    wsprintfW(manifest_path, L"%s%s", current_path, L"\\..\\..\\manifest.xml");
    wsprintfW(assembly_path, L"%s%s", current_path, L"\\..\\..\\..\\dll\\bin\\Release");


    PathResolve(manifest_path, NULL, 0);
    PathResolve(assembly_path, NULL, 0);

    wprintf(L"Path to meanifest: %s\nPath to assembly: %s\n", manifest_path, assembly_path);

    context.lpSource = manifest_path;
    context.lpAssemblyDirectory = assembly_path;
    context.dwFlags = ACTCTX_FLAG_ASSEMBLY_DIRECTORY_VALID;

    HANDLE hContext = CreateActCtxW(&context);
    if(!hContext || hContext == INVALID_HANDLE_VALUE)
        printf("CreateActCtx failed %d\n", (int)GetLastError());

    if(!ActivateActCtx(hContext, &cookie))
        printf("ActivateActCtx failed: %d\n", (int)GetLastError());

    HWND hMainWnd = CreateWindowA("sidebyside", "Test", WS_OVERLAPPED | WS_VISIBLE, 10, 10, 300, 300, NULL, NULL, NULL, 0);
    ok(hMainWnd != NULL, "CreateWindowA failed: %d\n", GetLastError());

    getchar();

    return 0;
}
